--select * from c6mart.gestione_Email where data_Generazione > getDate()-1 and tipo like '%pro%'
-- =============================================
-- Author:		<Valerio,,Name>
-- Create date: <19/14/2011,,> -1 ai -2!
-- Description:	<Popola la tabella email con i clienti con profilo scaduto>
-- =============================================
CREATE procedure [C6Mart].[RP_DM_GestioneEmailNOPRO]
AS
BEGIN
BEGIN TRANSACTION	
DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @MaxInvioSoll SMALLINT
DECLARE @ID_ELAB INT
SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') AS SMALLINT) --7
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') AS SMALLINT)
SET @ID_ELAB = C6MART.GETIDELAB()
-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'RP_DM_GestioneEmailNOPRO',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 1. INSERIMENTO MAIL "SOLLECITI"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA ATTIVATO UN PROFILO VALIDO AL CLIENTE
	-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
	INSERT INTO C6Mart.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(MD.numSolleciti,0) = 0 THEN '1_SOLL_NOPRO'
			WHEN MD.numSolleciti = 1 THEN '2_SOLL_NOPRO'
			WHEN MD.numSolleciti = 2 THEN '3_SOLL_NOPRO'
			ELSE 'S_SOLL_NOPRO'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'N'
		AND MD.profiloAttivo = 0
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		and vc.TIP_CONTRATTO<>3
		union 
			SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(MD.numSolleciti,0) = 0 THEN '1_SOLL_NOPRO_DA'
			WHEN MD.numSolleciti = 1 THEN '2_SOLL_NOPRO_DA'
			WHEN MD.numSolleciti = 2 THEN '3_SOLL_NOPRO_DA'
			ELSE 'S_SOLL_NOPRO_DA'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'N'
		AND MD.profiloAttivo = 0
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		and vc.TIP_CONTRATTO=3
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNOPRO'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 1.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- AGGIORNIAMO LA DATA Data_UltimoSollecito
	UPDATE 
		c6mart.CONTRATTOSEI_METADATI
	SET 
		numSolleciti = isnull(numSolleciti,0) + 1,
		Data_UltimoSollecito = getDate()
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'N'
		AND MD.profiloAttivo = 0
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'UPDATE',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNOPRO'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 2. INSERIMENTO MAIL "REVOCA"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA EFFETTUATO L'ATTIVAZIONE DEL PROFILO @MaxInvioSoll SOLLECITI
	-- N.B. OCCHIO ALLA CONDIZIONE -> (c6.risorseNA = 'N' AND numSolleciti = @MaxInvioSoll) OR  numSolleciti > @MaxInvioSoll
	--		OVVERO: BUONA L'ASSOCIAZIONE DELLE RISORSE EFFETTUATA DOPO L'ULTIMO SOLLECITO MA NON DOPO LA PRIMA REVOCA
	INSERT INTO C6Mart.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT  
		email.rete,
		email.cod_fiscale,
		'REVOCA_NOPRO' as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB --max(Data_Generazione)
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.ChiaveClientePb = VC.ChiaveClientePb
	INNER JOIN c6mart.gestione_Email EMAIL
		ON VC.RETE = EMAIL.RETE
		AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND EMAIL.Tipo IN ('S_SOLL_NOPRO','REVOCA_NOPRO')	
		AND (
				(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
				OR 
				(MD.numSolleciti = @MaxInvioSoll and MD.profiloAttivo = 0)-- SONO NEL CASO DI PRIMA REVOCA
			)
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		AND PF.RETE IS NULL
	GROUP BY email.rete, email.cod_fiscale
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNOPRO'
		)
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)
-- 2.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "REVOCA"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- NON AGGIORNIAMO LA DATA Data_UltimoSollecito
	-- N.B. VERIFICARE SE IL CAMPO Data_UltimoSollecito VA AGGIORNATO
	UPDATE c6mart.[CONTRATTOSEI_METADATI]
	SET 
		numRevoche = isnull(numRevoche,0) + 1,
		data_UltimaRevoca = getDate()
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.ChiaveClientePb = VC.ChiaveClientePb
	INNER JOIN c6mart.gestione_Email EMAIL
		ON VC.RETE = EMAIL.RETE
		AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND EMAIL.Tipo IN ('S_SOLL_NOPRO','REVOCA_NOPRO')	
		AND (
				(MD.numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
				OR 
				(MD.numSolleciti = @MaxInvioSoll and MD.profiloAttivo = 0)-- SONO NEL CASO DI PRIMA REVOCA
			)
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND (DATEDIFF(DAY,isnull(MD.Data_UltimaRevoca,MD.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		AND PF.RETE IS NULL
	update C6Mart.GESTIONE_EMAIL
	set Inviata = 'S', Data_Invio = getdate()
	where Cod_Fiscale = 'CRCTMS62A05H501D'
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'UPDATE',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNOPRO'
		)
COMMIT
END